<?php
// $Id: customfilter.export.inc,v 1.1.2.9.2.4 2009/06/25 12:55:11 kiam Exp $

/**
 * @file
 * Filters exporting functions.
 */

/**
 * @addtogroup customfilter
 * @{
 */

/***************************************************************************** 
 * Menu callbacks / form builders, submit/validate functions.
 ****************************************************************************/

/**
 * Return the export form.
 */
function customfilter_export_form(&$form_state) {
  $form = array();
  
  $step = isset($form_state['storage']['step']) ? $form_state['storage']['step'] : 1;
  
  switch ($step) {
    case 1:
      if ($filters = customfilter_get_filters()) {
        foreach ($filters as $filter) {
          $opt[$filter['fid']] = check_plain(t($filter['name']));
        }
        
        $form['filters'] = array(
          '#type' => 'radios',
          '#title' => t('Filters'),
          '#description' => 'Choose the filter to export.',
          '#options' => $opt,
        );
        
        $form['submit'] = array(
          '#type' => 'submit',
          '#value' => 'Export',
        );
      }
      else {
        $form['filters'] = array(
          '#type' => 'markup',
          '#value' => '<p>'. t('There are no custom filters defined.') .'</p>',
        );
      }
      break;
    
    case 2:
      $export_data = array();
      $fid = $form_state['values']['filters'];
      
      if ($filter = customfilter_get_filter($fid, '*')) {
        $export_data[] = '$filter = array(';
        $export_data[] = "  'fid' => _customfilter_map_filter_id('". $filter['fid'] ."'),";
        $export_data[] = "  'name' => base64_decode('". base64_encode($filter['name']) ."'),";
        $export_data[] = "  'cache' => {$filter['cache']},";
        $export_data[] = "  'description' => base64_decode('". base64_encode($filter['description']) ."'),";
        $export_data[] = "  'shorttips' => base64_decode('". base64_encode($filter['shorttips']) ."'),";
        $export_data[] = "  'longtips' => base64_decode('". base64_encode($filter['longtips']) ."'),";
        $export_data[] = ");";
        $export_data[] = '';
        
        $rules = array();
        _customfilter_get_rule_rows($rules, $fid, 0);
        foreach ($rules as $rule) {
          $export_data[] = '$rules[] = array(';
          $export_data[] = "  'rid' => _customfilter_map_rule_id('". $rule['rid'] ."'),";
          $export_data[] = "  'fid' => _customfilter_map_filter_id('". $filter['fid'] ."'),";
          $export_data[] = "  'prid' => _customfilter_map_rule_id('". $rule['prid'] ."'),";
          $export_data[] = "  'name' => base64_decode('". base64_encode($rule['name']) ."'),";
          $export_data[] = "  'description' => base64_decode('". base64_encode($rule['description']) ."'),";
          $export_data[] = "  'matches' => base64_decode('". base64_encode($rule['matches']) ."'),";
          $export_data[] = "  'pattern' => base64_decode('". base64_encode($rule['pattern']) ."'),";
          $export_data[] = "  'replacement' => base64_decode('". base64_encode($rule['replacement']) ."'),";
          $export_data[] = "  'code' => {$rule['code']},";
          $export_data[] = "  'weight' => {$rule['weight']},";
          $export_data[] = ");";
        }
      }
      
      if ($export_data = implode("\n", $export_data)) {
        $form['export'] = array(
          '#type' => 'textarea',
          '#title' => t('Export data'),
          '#description' => t('Copy the export text and paste it into the import form.'),
          '#cols' => 60,
          '#value' => $export_data,
          '#rows' => max(40, preg_match_all('/(\r\n?|\n)/', $export_data)),
        );
      }
      else {
        $form['export'] = array(
          '#type' => 'markup',
          '#value' => '<p>'. t('The selected filter has not been found in the database table.') .'</p>',
        );
      }
      break;
  }
  
  return $form;
}
 
function customfilter_export_form_submit($form, &$form_state) {
  $step = isset($form_state['storage']['step']) ? $form_state['storage']['step'] : 1;
  if ($step < 2) {
    $form_state['storage']['step'] = $step + 1;
  }
}

function _customfilter_get_rule_rows(&$rules, $fid, $prid = 0) {
  $result = db_query("SELECT * FROM {customfilter_rules} WHERE fid = %d and prid = %d ORDER BY weight", $fid, $prid);
  
  while ($rule = db_fetch_array($result)) {
    $rules[] = $rule;
    _customfilter_get_rule_rows($rules, $fid, $rule['rid']);
  }
}

/**
 * @} End of "addtogroup customfilter".
 */