<?php
// $Id: customfilter.import.inc,v 1.1.4.3 2009/06/25 12:55:11 kiam Exp $

/**
 * @file
 * Filters importing functions.
 */

/**
 * @addtogroup customfilter
 * @{
 */

/***************************************************************************** 
 * Menu callbacks / form builders, submit/validate functions.
 ****************************************************************************/

/**
 * Return the import form.
 */
function customfilter_import_form() {
  $form = array();
  
  $form['import'] = array(
    '#type' => 'textarea',
    '#title' => t('Import data'),
    '#description' => t('Paste the text you obtained from the export form.'),
    '#cols' => 60,
    '#value' => '',
    '#rows' => 40,
    '#required' => TRUE,
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Import'),
  );
  
  return $form;
}
 
function customfilter_import_form_submit($form, &$form_state) {
  @eval($form_state['values']['import']);
  
  if (!isset($filter) || !isset($rules) || !is_array($filter) || !is_array($rules)) {
    form_set_error('import', t('The import data is not valid import text.'));
    return;
  }
  
  drupal_write_record('customfilter_filters', $filter);
  
  foreach ($rules as $rule) {
    drupal_write_record('customfilter_rules', $rule);
  }
}

/*****************************************************************************
 * Private functions.
 ****************************************************************************/

function _customfilter_map_filter_id($id) {
  static $fids = array();
  
  if (isset($fids[$id])) {
    $fids[$id] = (integer) db_result(db_query("SELECT MAX(fid) FROM {customfilter_filters}")) + 1;
  }
  
  return $fids[$id];
}

function _customfilter_map_rule_id($id) {
  static $rids = array();
  
  if (isset($rids[$id])) {
    $rids[$id] = (integer) db_result(db_query("SELECT MAX(rid) FROM {customfilter_rules}")) + 1;
  }
  
  return $rids[$id];
}

/**
 * @} End of "addtogroup customfilter".
 */